unit AboutFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  ShellApi;

type
  TAboutForm = class(TForm)
    SoftVerLabel: TLabel;
    Bevel1: TBevel;
    Image2: TImage;
    Label2: TLabel;
    OkButton: TButton;
    Image3: TImage;
    Image4: TImage;
    EMailPanel: TPanel;
    URLPanel: TPanel;
    Label3: TLabel;
    VertPanel: TPanel;
    Image1: TImage;
    Label4: TLabel;
    procedure OkButtonClick(Sender: TObject);
    procedure EMailPanelClick(Sender: TObject);
    procedure URLPanelClick(Sender: TObject);
    procedure EMailPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure URLPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutForm: TAboutForm;

procedure ShowAboutForm;

implementation

uses Global, MainFrm;

{$R *.DFM}

procedure ShowAboutForm;
var
  Frm: TAboutForm;
begin
  Frm := TAboutForm.Create(Application);
  Frm.ShowModal;
  Frm.Free;
end;

procedure TAboutForm.FormCreate(Sender: TObject);
begin
  SoftVerLabel.Caption := 'Version ' + SVersion;
  URLPanel.Caption := SWebsite;
  EmailPanel.Caption := SEmail;
end;

procedure TAboutForm.OkButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TAboutForm.EMailPanelClick(Sender: TObject);
begin
  MainForm.HelpEmailItemClick(nil);
end;

procedure TAboutForm.URLPanelClick(Sender: TObject);
begin
  MainForm.HelpHomePageItemClick(nil);
end;

procedure TAboutForm.EMailPanelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if (X >=0) and (X < EMailPanel.Width) and (Y >=0) and (Y < EMailPanel.Height) then
  begin
    EMailPanel.Font.Style := [fsUnderline];
    EMailPanel.Font.Color := clRed;
    SetCapture(EMailPanel.Handle);
  end else
  begin
    EMailPanel.Font.Style := [];
    EMailPanel.Font.Color := clBlue;
    ReleaseCapture;
  end;
end;

procedure TAboutForm.URLPanelMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if (X >=0) and (X < URLPanel.Width) and (Y >=0) and (Y < URLPanel.Height) then
  begin
    URLPanel.Font.Style := [fsUnderline];
    URLPanel.Font.Color := clRed;
    SetCapture(URLPanel.Handle);
  end else
  begin
    URLPanel.Font.Style := [];
    URLPanel.Font.Color := clBlue;
    ReleaseCapture;
  end;
end;

end.
