unit ChildFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, StdActns, ActnList, ShellApi, Clipbrd, ComCtrls,
  Printers, HexEdit, Global;

const
  SDefaultFileName = 'Noname.dat';

type
  TCryptType = (ctGOST);
  TSearchKind = (skNone, skSearchText, skSearchHex, skSearchInt, skSearchFloat, skReplaceText, skReplaceHex);

  TChildForm = class(TForm)
    StatusBar: TStatusBar;
    HexEdit: THexEdit;
    MainMenu: TMainMenu;
    EditMenu: TMenuItem;
    EditUndoItem: TMenuItem;
    EditRedoItem: TMenuItem;
    EditN1Item: TMenuItem;
    EditCutItem: TMenuItem;
    EditCopyItem: TMenuItem;
    EditPasteItem: TMenuItem;
    EditSelAllItem: TMenuItem;
    EditN2Item: TMenuItem;
    EditChgLenItem: TMenuItem;
    EditInsertCharItem: TMenuItem;
    EditN3Item: TMenuItem;
    EditWriteBlockItem: TMenuItem;
    EditAdjustBlockItem: TMenuItem;
    EditDefBlockItem: TMenuItem;
    EditFillBlockItem: TMenuItem;
    B1: TMenuItem;
    EditN4Item: TMenuItem;
    EditConvItem: TMenuItem;
    EditConvCharsetItem: TMenuItem;
    EditConvCryptItem: TMenuItem;
    EditConvCaseItem: TMenuItem;
    SearchMenu: TMenuItem;
    SearchTextItem: TMenuItem;
    SearchHexItem: TMenuItem;
    SearchIntegerItem: TMenuItem;
    SearchFloatItem: TMenuItem;
    SearchN1Item: TMenuItem;
    SearchReplaceTextItem: TMenuItem;
    SearchReplaceHexItem: TMenuItem;
    SearchN2Item: TMenuItem;
    SearchNextItem: TMenuItem;
    SearchFirstItem: TMenuItem;
    SearchN3Item: TMenuItem;
    SearchCompareItem: TMenuItem;
    SearchCompareNextItem: TMenuItem;
    PosMenu: TMenuItem;
    PosGotoOffsetItem: TMenuItem;
    PosN1Item: TMenuItem;
    PosGotoFirstItem: TMenuItem;
    PosGotoEndItem: TMenuItem;
    PosN3Item: TMenuItem;
    PosGotoBlockStartItem: TMenuItem;
    PosGotoBlockEndItem: TMenuItem;
    PosN4Item: TMenuItem;
    PosGotoLineFirstItem: TMenuItem;
    PosGotoLineEndItem: TMenuItem;
    PosN2Item: TMenuItem;
    PosDefBookmarkItem: TMenuItem;
    PosDefBk1Item: TMenuItem;
    PosDefBk2Item: TMenuItem;
    PosDefBk3Item: TMenuItem;
    PosDefBk4Item: TMenuItem;
    PosDefBk5Item: TMenuItem;
    PosDefBk6Item: TMenuItem;
    PosDefBk7Item: TMenuItem;
    PosDefBk8Item: TMenuItem;
    PosDefBk9Item: TMenuItem;
    PosDefBk0Item: TMenuItem;
    PosGotoBookmarkItem: TMenuItem;
    PosGotoBk1Item: TMenuItem;
    PosGotoBk2Item: TMenuItem;
    PosGotoBk3Item: TMenuItem;
    PosGotoBk4Item: TMenuItem;
    PosGotoBk5Item: TMenuItem;
    PosGotoBk6Item: TMenuItem;
    PosGotoBk7Item: TMenuItem;
    PosGotoBk8Item: TMenuItem;
    PosGotoBk9Item: TMenuItem;
    PosGotoBk0Item: TMenuItem;
    ActionList: TActionList;
    UndoAction: TAction;
    RedoAction: TAction;
    CopyAction: TEditCopy;
    CutAction: TEditCut;
    PasteAction: TEditPaste;
    SelAllAction: TAction;
    WriteBlockAction: TAction;
    DeleteBlockAction: TAction;
    FillBlockAction: TAction;
    DefBlockAction: TAction;
    ChgLenAction: TAction;
    InsCharAction: TAction;
    GotoOffsetAction: TAction;
    ViewPopupMenu: TPopupMenu;
    PopupWriteBlockItem: TMenuItem;
    PopupFillBlockItem: TMenuItem;
    PopupN1Item: TMenuItem;
    PopupCutItem: TMenuItem;
    PopupCopyItem: TMenuItem;
    PopupPasteItem: TMenuItem;
    PopupN2Item: TMenuItem;
    PopupInsertCharItem: TMenuItem;
    PopupN3Item: TMenuItem;
    PopupShowNumBaseItem: TMenuItem;
    PopupShowBkmkMgrItem: TMenuItem;
    SaveDialog: TSaveDialog;
    CurValuePopupMenu: TPopupMenu;
    CurValPopup8sItem: TMenuItem;
    CurValPopup8uItem: TMenuItem;
    CurValPopup16sItem: TMenuItem;
    CurValPopup16uItem: TMenuItem;
    CurValPopup32sItem: TMenuItem;
    CurValPopup32uItem: TMenuItem;
    CurValPopupSingleItem: TMenuItem;
    CurValPopupDoubleItem: TMenuItem;
    BlockInfoPopupMenu: TPopupMenu;
    BlkPopupDecItem: TMenuItem;
    BlkPopupHexItem: TMenuItem;
    BlkPopupN1Item: TMenuItem;
    BlkPopupDefBlockItem: TMenuItem;
    BlkPopupN2Item: TMenuItem;
    BlkPopupBlockLenItem: TMenuItem;
    OffsetPopupMenu: TPopupMenu;
    OffPopupDecItem: TMenuItem;
    OffPopupHexItem: TMenuItem;
    OffPopupN1Item: TMenuItem;
    OffPopupGotoItem: TMenuItem;
    LengthPopupMenu: TPopupMenu;
    LenPopupDecItem: TMenuItem;
    LenPopupHexItem: TMenuItem;
    LenPopupN1Item: TMenuItem;
    LenPopupChgLenItem: TMenuItem;
    AdjustBlockAction: TAction;
    PopupN4Item: TMenuItem;
    PopupUndoItem: TMenuItem;
    PopupRedoItem: TMenuItem;
    procedure UndoActionExecute(Sender: TObject);
    procedure RedoActionExecute(Sender: TObject);
    procedure CopyActionExecute(Sender: TObject);
    procedure CutActionExecute(Sender: TObject);
    procedure PasteActionExecute(Sender: TObject);
    procedure SelAllActionExecute(Sender: TObject);
    procedure ChgLenActionExecute(Sender: TObject);
    procedure HexEditCaretMove(Sender: TObject);
    procedure HexEditSelectionChange(Sender: TObject);
    procedure StatusBarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HexEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure InsCharActionExecute(Sender: TObject);
    procedure WriteBlockActionExecute(Sender: TObject);
    procedure DeleteBlockActionExecute(Sender: TObject);
    procedure FillBlockActionExecute(Sender: TObject);
    procedure DefBlockActionExecute(Sender: TObject);
    procedure AdjustBlockActionExecute(Sender: TObject);
    procedure EditConvCharsetItemClick(Sender: TObject);
    procedure EditConvCryptItemClick(Sender: TObject);
    procedure EditConvCaseItemClick(Sender: TObject);
    procedure SearchTextItemClick(Sender: TObject);
    procedure SearchHexItemClick(Sender: TObject);
    procedure SearchIntegerItemClick(Sender: TObject);
    procedure SearchFloatItemClick(Sender: TObject);
    procedure SearchReplaceTextItemClick(Sender: TObject);
    procedure SearchReplaceHexItemClick(Sender: TObject);
    procedure SearchNextItemClick(Sender: TObject);
    procedure SearchFirstItemClick(Sender: TObject);
    procedure SearchCompareItemClick(Sender: TObject);
    procedure SearchCompareNextItemClick(Sender: TObject);
    procedure CurValPopup8sItemClick(Sender: TObject);
    procedure CurValPopup8uItemClick(Sender: TObject);
    procedure CurValPopup16sItemClick(Sender: TObject);
    procedure CurValPopup16uItemClick(Sender: TObject);
    procedure CurValPopup32sItemClick(Sender: TObject);
    procedure CurValPopup32uItemClick(Sender: TObject);
    procedure CurValPopupSingleItemClick(Sender: TObject);
    procedure CurValPopupDoubleItemClick(Sender: TObject);
    procedure LenPopupDecItemClick(Sender: TObject);
    procedure LenPopupHexItemClick(Sender: TObject);
    procedure OffPopupDecItemClick(Sender: TObject);
    procedure OffPopupHexItemClick(Sender: TObject);
    procedure BlkPopupDecItemClick(Sender: TObject);
    procedure BlkPopupHexItemClick(Sender: TObject);
    procedure BlockInfoPopupMenuPopup(Sender: TObject);
    procedure GotoOffsetActionExecute(Sender: TObject);
    procedure PosGotoFirstItemClick(Sender: TObject);
    procedure PosGotoEndItemClick(Sender: TObject);
    procedure PosGotoBlockStartItemClick(Sender: TObject);
    procedure PosGotoBlockEndItemClick(Sender: TObject);
    procedure PosGotoLineFirstItemClick(Sender: TObject);
    procedure PosGotoLineEndItemClick(Sender: TObject);
    procedure PosDefBkItemClick(Sender: TObject);
    procedure PosGotoBkItemClick(Sender: TObject);
    procedure PosDefBookmarkItemClick(Sender: TObject);
    procedure PosGotoBookmarkItemClick(Sender: TObject);
    procedure PopupShowNumBaseItemClick(Sender: TObject);
    procedure HexEditDblClick(Sender: TObject);
    procedure PopupShowBkmkMgrItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure StatusBarResize(Sender: TObject);
  private
    { Private declarations }
    FFileName: string;
    FDisplayName: string;     //ʾҳл
    FIsNewDoc: Boolean;       //ǲ½ĵ
    FShowing: Boolean;        //ӴǷʾ

    function GetDataSize: Integer;
    function GetDisplayName: string;

    procedure SetLengthNumBase(Value: TNumBase);
    procedure SetOffsetNumBase(Value: TNumBase);
    procedure SetBlockInfoNumBase(Value: TNumBase);
    procedure SetCurValueType(Value: TValueType);

    procedure InitBounds;
    procedure InitEditorAppearance;

    procedure ShowStatusInfo;
    procedure ShowOffset;
    procedure ShowLength;
    procedure ShowBlockInfo;
    procedure ShowCurValue;
    procedure ShowModifyFlag;

    function SaveToFile(const FileName: string): Boolean;
    procedure AdjustUndoRedoEnabled;
    procedure AdjustClipboardEnabled;
    procedure AdjustBlockEnabled;
    function CheckSelExists: Boolean;
    procedure CreateBackup;
  public
    { Public declarations }
    function NewBuffer(Size: Integer): Boolean;
    function LoadFromFile(const FileName: string): Boolean;
    function Save: Boolean;
    function SaveAs: Boolean;
    function Execute: Boolean;
    function OpenWithEditor: Boolean;
    function Print: Boolean;
    function ExportToText: Boolean;
    function LoadFromLogicSector(Drive: Char; SectorStart, SectorCount: Integer): Boolean;
    function SaveToLogicSector(Drive: Char; SectorStart: Integer): Boolean;

    procedure ReDraw;
    procedure FillDataInspector;
    procedure SearchText;
    procedure GotoAddress;
    procedure Undo;
    procedure Redo;

    property FileName: string read FFileName;
    property DisplayName: string read GetDisplayName;
    property DataSize: Integer read GetDataSize;
  end;

var
  ChildForm: TChildForm;

implementation

uses
  Misc, SysOptMgr, OptionFrm, MainFrm, InsCharFrm, SetSizeFrm, AdjBlockFrm,
  DefBlockFrm, FillBlockFrm, GotoOffsetFrm, SearchTextFrm, SearchHexFrm,
  SearchIntFrm, SearchFloatFrm, ReplaceTextFrm, ReplaceHexFrm, ExportFrm,
  ProgressFrm, PrintFrm, ConvCryptFrm, ConvCaseFrm, ConvChrsetFrm, DataCompFrm,
  NumBaseConvFrm, BkmkMgrFrm, DataInspFrm, Gost, Search, Compare, NumBase,
  DiskIO, TransCharset;

var
  SearchMgr: TSearchMgr;           //
  CompareMgr: TCompareMgr;         //ݱȽ

{$R *.dfm}

{ Misc }

procedure ShowWinNoAnimate(Handle: HWnd; CmdShow: Integer);

  function GetAnimation: Boolean;
  var
    Info: TAnimationInfo;
  begin
    Info.cbSize := SizeOf(TAnimationInfo);
    if SystemParametersInfo(SPI_GETANIMATION, SizeOf(Info), @Info, 0) then
      Result := Info.iMinAnimate <> 0 else
      Result := False;
  end;

  procedure SetAnimation(Value: Boolean);
  var
    Info: TAnimationInfo;
  begin
    Info.cbSize := SizeOf(TAnimationInfo);
    BOOL(Info.iMinAnimate) := Value;
    SystemParametersInfo(SPI_SETANIMATION, SizeOf(Info), @Info, 0);
  end;

var
  Animation: Boolean;
begin
  Animation := GetAnimation;
  if Animation then SetAnimation(False);
  ShowWindow(Handle, CmdShow);
  if Animation then SetAnimation(True);
end;

{ TChildForm }

function TChildForm.GetDataSize: Integer;
begin
  Result := HexEdit.DataSize;
end;

function TChildForm.GetDisplayName: string;
begin
  Result := FDisplayName;
end;

procedure TChildForm.SetLengthNumBase(Value: TNumBase);
begin
  LenPopupDecItem.Checked := (Value = raDec);
  LenPopupHexItem.Checked := (Value <> raDec);
  OptMgr.Values[SOptStatusLengthNumBase] := Value;
  ShowLength;
end;

procedure TChildForm.SetOffsetNumBase(Value: TNumBase);
begin
  OffPopupDecItem.Checked := (Value = raDec);
  OffPopupHexItem.Checked := (Value <> raDec);
  OptMgr.Values[SOptStatusOffsetNumBase] := Value;
  ShowOffset;
end;

procedure TChildForm.SetBlockInfoNumBase(Value: TNumBase);
begin
  BlkPopupDecItem.Checked := (Value = raDec);
  BlkPopupHexItem.Checked := (Value <> raDec);
  OptMgr.Values[SOptStatusBlockInfoNumBase] := Value;
  ShowBlockInfo;
end;

procedure TChildForm.SetCurValueType(Value: TValueType);
begin
  CurValPopup8sItem.Checked := (Value = vt8s);
  CurValPopup8uItem.Checked := (Value = vt8u);
  CurValPopup16sItem.Checked := (Value = vt16s);
  CurValPopup16uItem.Checked := (Value = vt16u);
  CurValPopup32sItem.Checked := (Value = vt32s);
  CurValPopup32uItem.Checked := (Value = vt32u);
  CurValPopupSingleItem.Checked := (Value = vtSingle);
  CurValPopupDoubleItem.Checked := (Value = vtDouble);

  OptMgr.Values[SOptStatusCurValueType] := Value;
  ShowCurValue;
end;

procedure TChildForm.InitBounds;
begin
  if MainForm.GetDocCount = 1 then
  begin
    BoundsRect := MainForm.GetMDIClientRect;
    ShowWinNoAnimate(Handle, SW_MAXIMIZE);
  end;
end;

procedure TChildForm.InitEditorAppearance;
begin
  GetEditFontFromOpt(HexEdit.Font);
  HexEdit.Colors.AddressBackColor := OptMgr.Values[SOptAddrBColor];
  HexEdit.Colors.AddressForeColor := OptMgr.Values[SOptAddrFColor];
  HexEdit.Colors.HexBackColor := OptMgr.Values[SOptHexBColor];
  HexEdit.Colors.HexForeColor := OptMgr.Values[SOptHexFColor];
  HexEdit.Colors.CharBackColor := OptMgr.Values[SOptChrBColor];
  HexEdit.Colors.CharForeColor := OptMgr.Values[SOptChrFColor];
  HexEdit.Colors.SelectionBackColor := OptMgr.Values[SOptBlockBColor];
  HexEdit.Colors.SelectionForeColor := OptMgr.Values[SOptBlockFColor];
  HexEdit.Colors.CaretBackColor := OptMgr.Values[SOptCurItemBColor];
  HexEdit.Colors.CaretForeColor := OptMgr.Values[SOptCurItemFColor];
  HexEdit.DrawCharStyle := TDrawCharStyle(OptMgr.Values[SOptDrawCharStyle]);
end;

procedure TChildForm.ShowStatusInfo;
begin
  StatusBar.Panels.BeginUpdate;
  ShowLength;
  ShowOffset;
  ShowBlockInfo;
  ShowCurValue;
  ShowModifyFlag;
  StatusBar.Panels.EndUpdate;
end;

procedure TChildForm.ShowOffset;
var
  S: string;
  Value: Integer;
begin
  Value := HexEdit.Offset;
  S := 'ƫ: ';
  if OptMgr.Values[SOptStatusOffsetNumBase] = raDec then
    S := S + Format('%10dD', [Value])
  else
    S := S + '  ' + IntToHex(Value, 8) + 'H';
  StatusBar.Panels[1].Text := S;
end;

procedure TChildForm.ShowLength;
var
  S: string;
  Value: Integer;
begin
  Value := HexEdit.DataSize;
  S := ': ';
  if OptMgr.Values[SOptStatusLengthNumBase] = raDec then
    S := S + Format('%10dD', [Value])
  else
    S := S + '  ' + IntToHex(Value, 8) + 'H';
  StatusBar.Panels[0].Text := S;
end;

procedure TChildForm.ShowBlockInfo;
var
  S: string;
begin
  S := 'Ϣ: ';
  if HexEdit.SelLength > 0 then
  begin
    if OptMgr.Values[SOptStatusBlockInfoNumBase] = raDec then
      S := S + Format('%10dD', [HexEdit.SelStart]) +
        ' - '+ Format('%10dD', [HexEdit.SelStart + HexEdit.SelLength - 1])
    else
      S := S + '  ' + IntToHex(HexEdit.SelStart, 8) + 'H' +
              ' - ' + IntToHex(HexEdit.SelStart + HexEdit.SelLength, 8) + 'H';
  end else
  begin
    S := S + '(δ)'
  end;
  StatusBar.Panels[2].Text := S;
end;

procedure TChildForm.ShowCurValue;
var
  S: string;
  P: Pointer;
  Offset: Integer;
begin
  Offset := HexEdit.Offset;
  P := HexEdit.DataAddr + HexEdit.Offset;
  S := '';
  case TValueType(OptMgr.Values[SOptStatusCurValueType]) of
    vt8s:
      S := IntToStr(PShortInt(P)^);
    vt8u:
      S := IntToStr(PByte(P)^);
    vt16s:
      if Offset + 2 <= HexEdit.DataSize then
        S := IntToStr(PSmallInt(P)^);
    vt16u:
      if Offset + 2 <= HexEdit.DataSize then
        S := IntToStr(PWord(P)^);
    vt32s:
      if Offset + 4 <= HexEdit.DataSize then
        S := IntToStr(PLongInt(P)^);
    vt32u:
      if Offset + 4 <= HexEdit.DataSize then
        S := IntToStr(PLongWord(P)^);
    vtSingle:
      if Offset + 4 <= HexEdit.DataSize then
        S := Format('%2.8e', [PSingle(P)^]);
    vtDouble:
      if Offset + 8 <= HexEdit.DataSize then
        S := Format('%2.8e', [PDouble(P)^]);
  end;
  StatusBar.Panels[3].Text := 'ǰֵ: ' +  S;
end;

procedure TChildForm.ShowModifyFlag;
var
  S: string;
begin
  if HexEdit.Modified then S := '޸'
  else S := 'δ޸';
  StatusBar.Panels[4].Text := S;
end;

function TChildForm.SaveToFile(const FileName: string): Boolean;
begin
  Result := True;
  try
    HexEdit.SaveToFile(FileName);
  except
    Result := False;
  end;
end;

procedure TChildForm.AdjustUndoRedoEnabled;
begin
  UndoAction.Enabled := HexEdit.CanUndo;
  RedoAction.Enabled := HexEdit.CanRedo;
  MainForm.UndoToolButton.Enabled := UndoAction.Enabled;
  MainForm.RedoToolButton.Enabled := RedoAction.Enabled;
end;

procedure TChildForm.AdjustClipboardEnabled;
begin
  CutAction.Enabled := HexEdit.SelLength > 0;
  CopyAction.Enabled := HexEdit.SelLength > 0;
  PasteAction.Enabled := HexEdit.CanPaste;
  MainForm.CutToolButton.Enabled := CutAction.Enabled;
  MainForm.CopyToolButton.Enabled := CopyAction.Enabled;
  MainForm.PasteToolButton.Enabled := PasteAction.Enabled;
end;

procedure TChildForm.AdjustBlockEnabled;
var
  BlockExists: Boolean;
begin
  BlockExists := HexEdit.SelLength > 0;
  WriteBlockAction.Enabled := BlockExists;
  DeleteBlockAction.Enabled := BlockExists;
  FillBlockAction.Enabled := BlockExists;
  AdjustBlockAction.Enabled := BlockExists;
  PosGotoBlockStartItem.Enabled := BlockExists;
  PosGotoBlockEndItem.Enabled := BlockExists;
end;

function TChildForm.CheckSelExists: Boolean;
begin
  Result := HexEdit.SelLength > 0;
  if not Result then
  begin
    MsgBox('黹ûж壡');
  end;
end;

procedure TChildForm.CreateBackup;
begin
  if OptMgr.Values[SOptCreateBak] and not FIsNewDoc then
    CreateBakFile(FFileName, 'bak');
end;

function TChildForm.NewBuffer(Size: Integer): Boolean;
begin
  Result := True;
  try
    HexEdit.DataSize := Size;
    HexEdit.Modified := False;
    FFileName := SDefaultFileName;
    FDisplayName := SDefaultFileName;
    Caption := SDefaultFileName;
    FIsNewDoc := True;
    ShowStatusInfo;
    FillDataInspector;
  except
    MsgBox('ڴ', MB_OK + MB_ICONERROR);
    Result := False;
  end;
end;

function TChildForm.LoadFromFile(const FileName: string): Boolean;
begin
  Result := True;
  try
    HexEdit.LoadFromFile(FileName);
    FFileName := GetFullFileName(FileName);
    FDisplayName := ExtractFileName(FFileName);
    Caption := FFileName;
    FIsNewDoc := False;
    ShowStatusInfo;
    FillDataInspector;
  except
    Result := False;
  end;
end;

function TChildForm.Save: Boolean;
var
  FileName: string;
  SaveDialog: TSaveDialog;
  R: Integer;
begin
  Result := False;
  BringToFront;

  if FIsNewDoc then
  begin
    SaveDialog := TSaveDialog.Create(Self);
    try
      SaveDialog.Title := '';
      SaveDialog.Filter := 'ļ(*.*)|*.*';
      SaveDialog.Options := SaveDialog.Options + [ofOverwritePrompt];
      if SaveDialog.Execute then
        FileName := SaveDialog.FileName
      else
        Exit;
    finally
      SaveDialog.Free;
    end;
  end else
  begin
    FileName := FFileName;
    if OptMgr.Values[SOptPromptSave] then
    begin
      R := MsgBox('ȷҪҪ', MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON2);
      if R = ID_NO then Exit;
    end;
  end;

  CreateBackup;
  
  if SaveToFile(FileName) then
  begin
    FFileName := FileName;
    FDisplayName := ExtractFileName(FFileName);
    Caption := FFileName;
    HexEdit.Modified := False;
    ShowModifyFlag;
    MainForm.ChildRenameNotify(Self);
    MainForm.ChildSaveNotify(Self, FIsNewDoc);
    FIsNewDoc := False;
    Result := True;
  end else
  begin
    MsgBox(Format('ļ%sʧܡ' + #13 +
      'ļΪֻռá', [FFileName]),
       MB_OK + MB_ICONERROR);
    Result := False;
  end;
end;

function TChildForm.SaveAs: Boolean;
var
  FileName: string;
  SaveDialog: TSaveDialog;
begin
  Result := False;

  SaveDialog := TSaveDialog.Create(Self);
  try
    SaveDialog.Title := 'Ϊ';
    SaveDialog.Filter := 'ļ(*.*)|*.*';
    SaveDialog.Options := SaveDialog.Options + [ofOverwritePrompt];
    SaveDialog.FileName := FFileName;

    if SaveDialog.Execute then
    begin
      CreateBackup;

      FileName := SaveDialog.FileName;
      if SaveToFile(FileName) then
      begin
        FFileName := FileName;
        FDisplayName := ExtractFileName(FFileName);
        Caption := FFileName;
        HexEdit.Modified := False;
        ShowModifyFlag;
        MainForm.ChildRenameNotify(Self);
        MainForm.ChildSaveNotify(Self, True);
        FIsNewDoc := False;
        Result := True;
      end else
      begin
        MsgBox('޷棬Ƿд', MB_OK + MB_ICONERROR);
        Result := False;
      end;
    end;
  finally
    SaveDialog.Free;
  end;
end;

function TChildForm.Execute: Boolean;
var
  TempFileName: string;
  Hnd: THandle;
  Ret: Boolean;
  R: Integer;
begin
  Result := False;
  TempFileName := OptMgr.Values[SOptTempPath] + ExtractFileName(FFileName);
  if GetFullFileName(FFileName) = GetFullFileName(TempFileName) then
  begin
    MsgBox('޷ִиòȷʱļ·');
    Exit;
  end;

  ShowProgressForm('Ϊ׼...', True);
  try
    Ret :=  SaveToFile(TempFileName);
  finally
    ShowProgressForm('', False);
  end;

  if Ret then
  begin
    Hnd := ShellExecute(Application.Handle, 'Open', PChar(TempFileName), '', '', 1);
    if Hnd <= 32 then
      MsgBox(Format('ļ %s ִʧܡ', [TempFileName]));
    R := MsgBox(Format('ɾʱļ %s ', [TempFileName]), MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON1);
    if R = ID_YES then
      if not DeleteFile(TempFileName) then
        MsgBox(Format('ļ %s ޷ɾ', [TempFileName]));
    Result := (Hnd > 32);
  end else
  begin
    MsgBox(Format('޷ʱļ %s ', [TempFileName]), MB_OK + MB_ICONERROR);
  end;
end;

function TChildForm.OpenWithEditor: Boolean;
var
  TempFileName: string;
  Ret: Boolean;
  ExecResult: Integer;
  R: Integer;
begin
  Result := False;
  TempFileName := OptMgr.Values[SOptTempPath] + ExtractFileName(FFileName);
  if GetFullFileName(FFileName) = GetFullFileName(TempFileName) then
  begin
    MsgBox('޷ִиòȷʱļ·');
    Exit;
  end;

  ShowProgressForm('Ϊ׼...', True);
  try
    Ret := SaveToFile(TempFileName);
  finally
    ShowProgressForm('', False);
  end;

  if Ret then
  begin
    ExecResult := WinExec(PChar(string(OptMgr.Values[SOptDefEditor]) + ' ''' + TempFileName + ''''), 1);
    if ExecResult <= 32 then
      MsgBox(Format('ļ %s ִʧܡ', [TempFileName]));
    R := MsgBox(Format('ɾʱļ %s ', [TempFileName]), MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON1);
    if R = ID_YES then
      if not DeleteFile(TempFileName) then
        MsgBox(Format('ļ %s ޷ɾ', [TempFileName]));
    Result := (ExecResult > 32);
  end else
  begin
    MsgBox(Format('޷ʱļ %s ', [TempFileName]), MB_OK + MB_ICONERROR);
  end;
end;

function TChildForm.Print: Boolean;
var
  FormData: TPrintData;
  Lines: TStrings;
  I, X, Y: Integer;
begin
  Result := ShowPrintForm(FormData);
  if Result then
  begin
    Lines := TStringList.Create;
    try
      ShowProgressForm('ڴӡ...', True);
      HexEdit.GetEditorText(Lines, FormData.IncAddr, FormData.OnlyBlock);
      ShowProgressForm('', False);
      if Lines.Count = 0 then Exit;

      if FormData.PrintFileName then
      begin
        Lines.Insert(0, FFileName);
        Lines.Insert(0, '');
      end;

      try
        Printer.BeginDoc;
        try
          X := 10;
          Y := 10;
          for I := 0 to Lines.Count - 1 do
          begin
            Printer.Canvas.TextOut(X, Y, Lines[I]);
            Y := Y + Printer.Canvas.TextHeight(Lines[I]) + 5;
          end;
        finally
          Printer.EndDoc;
        end;
      except
        MsgBox('ӡʱִӡǷȷװ', MB_OK + MB_ICONERROR);
      end;
    finally
      Lines.Free;
    end;
  end;
end;

function TChildForm.ExportToText: Boolean;
var
  FormData: TExportData;
  Lines: TStrings;
begin
  Result := ShowExportForm(FormData);
  if Result then
  begin
    Lines := TStringList.Create;
    try
      ShowProgressForm('ڵ...', True);
      HexEdit.GetEditorText(Lines, FormData.IncAddr, FormData.OnlyBlock);
      ShowProgressForm('', False);
      Lines.SaveToFile(FormData.FileName);
    finally
      Lines.Free;
    end;
  end;
end;

//-----------------------------------------------------------------------------
// : ߼
// :
//   Drive       - ( 'C', 'D')
//   SectorStart - ʼ(0-based)
//   SectorCount - 
//-----------------------------------------------------------------------------
function TChildForm.LoadFromLogicSector(Drive: Char; SectorStart, SectorCount: Integer): Boolean;
var
  DataStream: TMemoryStream;
begin
  DataStream := TMemoryStream.Create;
  try
    Result := DiskIOObject.ReadLogicalSector(Drive, SectorStart, SectorCount, DataStream);
    if Result then
    begin
      DataStream.Position := 0;
      HexEdit.LoadFromStream(DataStream);
      HexEdit.Modified := False;
      FFileName := SDefaultFileName;
      FDisplayName := Format('%s: %d - %d', [UpCase(Drive), SectorStart, SectorStart + SectorCount - 1]);
      Caption := FDisplayName;
      FIsNewDoc := True;
      ShowStatusInfo;
      FillDataInspector;
    end;
  finally
    DataStream.Free;
  end;
end;

//-----------------------------------------------------------------------------
// : д߼
// :
//   Drive       - ( 'C', 'D')
//   SectorStart - ʼ(0-based)
//-----------------------------------------------------------------------------
function TChildForm.SaveToLogicSector(Drive: Char; SectorStart: Integer): Boolean;
var
  SectorCount: Integer;
  DataStream: TMemoryStream;
begin
  SectorCount := HexEdit.DataSize div DiskIO.BytesPerSector;
  DataStream := TMemoryStream.Create;
  try
    DataStream.SaveToStream(DataStream);
    Result := DiskIOObject.WriteLogicalSector(Drive, SectorStart, SectorCount, DataStream);
  finally
    DataStream.Free;
  end;
end;

procedure TChildForm.ReDraw;
begin
  InitEditorAppearance;
  HexEdit.Invalidate;
end;

procedure TChildForm.FillDataInspector;
var
  ValuePtr: Pointer;
  MaxByte: Integer;
begin
  if not DataInspForm.Visible then Exit;
  ValuePtr := HexEdit.DataAddr + HexEdit.Offset;
  MaxByte := HexEdit.DataSize - HexEdit.Offset;
  DataInspForm.SetData(ValuePtr, MaxByte);
end;

procedure TChildForm.SearchText;
begin
  SearchTextItemClick(nil);
end;

procedure TChildForm.GotoAddress;
begin
  GotoOffsetActionExecute(nil);
end;

procedure TChildForm.Undo;
begin
  HexEdit.Undo;
  AdjustUndoRedoEnabled;
end;

procedure TChildForm.Redo;
begin
  HexEdit.Redo;
  AdjustUndoRedoEnabled;
end;

procedure TChildForm.FormCreate(Sender: TObject);
begin
  FFileName := SDefaultFileName;
  FIsNewDoc := True;
  FShowing := True;
  AdjustUndoRedoEnabled;
  AdjustClipboardEnabled;
  AdjustBlockEnabled;
  InitEditorAppearance;
  MainForm.ChildOpenNotify(Self);
end;

procedure TChildForm.FormActivate(Sender: TObject);
begin
  FillDataInspector;
  AdjustUndoRedoEnabled;
  AdjustClipboardEnabled;
  AdjustBlockEnabled;
  if FShowing then
  begin
    InitBounds;
    FShowing := False;
  end;
  MainForm.ChildActiveNotify(Self);
end;

procedure TChildForm.FormShow(Sender: TObject);
begin
//
end;

procedure TChildForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  MainForm.ChildCloseNotify(Self);
end;

procedure TChildForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  R: Integer;
begin
  CanClose := True;
  if HexEdit.Modified then
  begin
    BringToFront;
    R := MsgBox('ѱ޸ģǷ񱣴棿', MB_YESNOCANCEL + MB_ICONQUESTION + MB_DEFBUTTON1);
    if R = ID_YES then
      if not Save then CanClose := False;
    if R = ID_CANCEL then
      CanClose := False;
  end;
end;

procedure TChildForm.UndoActionExecute(Sender: TObject);
begin
  Undo;
end;

procedure TChildForm.RedoActionExecute(Sender: TObject);
begin
  Redo;
end;

procedure TChildForm.CopyActionExecute(Sender: TObject);
begin
  HexEdit.CopyToClipboard;
  AdjustClipboardEnabled;
end;

procedure TChildForm.CutActionExecute(Sender: TObject);
begin
  HexEdit.CutToClipboard;
  AdjustClipboardEnabled;
end;

procedure TChildForm.PasteActionExecute(Sender: TObject);
begin
  HexEdit.PasteFromClipboard;
  AdjustClipboardEnabled;
end;

procedure TChildForm.SelAllActionExecute(Sender: TObject);
begin
  HexEdit.SelectAll;
end;

procedure TChildForm.ChgLenActionExecute(Sender: TObject);
var
  BufSize: Integer;
begin
  BufSize := HexEdit.DataSize;
  if ShowSetSizeForm(BufSize, '޸ĳ', 'µĳ(ֽ):') then
  begin
    HexEdit.DataSize := BufSize;
  end;
end;

procedure TChildForm.InsCharActionExecute(Sender: TObject);

  procedure InsertChar(Ch: Char; Count: Integer);
  var
    S: string;
  begin
    S := StringOfChar(Ch, Count);
    HexEdit.InsertData(HexEdit.Offset, S[1], Count, True);
  end;

  procedure InsertRandomChar(StartVal, EndVal, Count: Integer);
  var
    S: string;
    I: Integer;
  begin
    Randomize;
    SetLength(S, Count);
    for I := 1 to Count do
      S[I] := Chr(Random(EndVal - StartVal + 1) + StartVal);
    HexEdit.InsertData(HexEdit.Offset, S[1], Count, True);
  end;

var
  FormData: TInsCharData;
begin
  if ShowInsCharForm(FormData) then
  begin
    if FormData.Fixed then
      InsertChar(Char(FormData.FixValue), FormData.Count)
    else
      InsertRandomChar(FormData.RndFromVal, FormData.RndToVal, FormData.Count);
  end;
end;

procedure TChildForm.WriteBlockActionExecute(Sender: TObject);
var
  SaveDialog: TSaveDialog;
  FileStream: TFileStream;
  FileName: string;
begin
  if not CheckSelExists then Exit;

  SaveDialog := TSaveDialog.Create(Self);
  try
    SaveDialog.Title := 'дļ';
    SaveDialog.Filter := 'ļ(*.*)|*.*';
    SaveDialog.Options := SaveDialog.Options + [ofOverwritePrompt];
    if SaveDialog.Execute then
    begin
      FileName := SaveDialog.FileName;
      try
        FileStream := TFileStream.Create(FileName, fmCreate or fmShareExclusive);
        try
          FileStream.Write((HexEdit.DataAddr + HexEdit.SelStart)^, HexEdit.SelLength);
        finally
          FileStream.Free;
        end;
      except
        raise;
        MsgBox('޷дļǷд', MB_OK + MB_ICONERROR);
      end;
    end;
  finally
    SaveDialog.Free;
  end;
end;

procedure TChildForm.DeleteBlockActionExecute(Sender: TObject);
begin
  if HexEdit.SelLength = 0 then Exit;

  if HexEdit.SelLength = HexEdit.DataSize then
  begin
    MsgBox('ɾ');
    Exit;
  end;

  HexEdit.DeleteSelection(True);
  ShowStatusInfo;
  FillDataInspector;
end;

procedure TChildForm.FillBlockActionExecute(Sender: TObject);
var
  FormData: TFillBlockData;
  S: string;
  I, Count: Integer;
begin
  if not CheckSelExists then Exit;

  if ShowFillBlockForm(FormData) then
  begin
    Count := HexEdit.SelLength;
    if FormData.Fixed then
    begin
      S := StringOfChar(Chr(FormData.FixValue), Count);
    end else
    begin
      Randomize;
      SetLength(S, Count);
      for I := 1 to Count do
        S[I] := Chr(Random(FormData.RndToVal - FormData.RndFromVal + 1) + FormData.RndToVal);
    end;
    HexEdit.ModifyData(HexEdit.SelStart, S[1], Count, True);

    ShowStatusInfo;
    FillDataInspector;
  end;
end;

procedure TChildForm.DefBlockActionExecute(Sender: TObject);
var
  FormData: TDefBlockData;
begin
  FormData.StartOffset := HexEdit.SelStart;
  FormData.EndOffset := HexEdit.SelStart + HexEdit.SelLength - 1;
  if ShowDefBlockForm(FormData) then
  begin
    HexEdit.SelStart := FormData.StartOffset;
    HexEdit.SelLength := FormData.EndOffset - FormData.StartOffset + 1;
    ShowStatusInfo;
  end;
end;

procedure TChildForm.AdjustBlockActionExecute(Sender: TObject);
var
  FormData: TAdjBlockData;
  SelStart, SelEnd: Integer;
begin
  if not CheckSelExists then Exit;

  if ShowAdjBlockForm(FormData) then
  begin
    SelStart := HexEdit.SelStart;
    SelEnd := HexEdit.SelStart + HexEdit.SelLength - 1;

    if FormData.AdjPos then
    begin
      if FormData.PosDire = 0 then
      begin
        Dec(SelStart, FormData.PosDist);
        Dec(SelEnd, FormData.PosDist);
      end else
      begin
        Inc(SelStart, FormData.PosDist);
        Inc(SelEnd, FormData.PosDist);
      end;
    end else
    begin
      if FormData.SizeStartDire = 0 then
        Dec(SelStart, FormData.SizeStartDist)
      else
        Inc(SelStart, FormData.SizeStartDist);
      if FormData.SizeEndDire = 0 then
        Dec(SelEnd, FormData.SizeEndDist)
      else
        Inc(SelEnd, FormData.SizeEndDist);
    end;
    if SelStart < 0 then SelStart := 0;
    if SelEnd < 0 then SelEnd := 0;
    if SelStart >= HexEdit.DataSize then SelStart := HexEdit.DataSize - 1;
    if SelEnd >= HexEdit.DataSize then SelEnd := HexEdit.DataSize - 1;

    HexEdit.SelStart := SelStart;
    HexEdit.SelLength := SelEnd - SelStart + 1;

    ShowStatusInfo;
  end;
end;

procedure TChildForm.GotoOffsetActionExecute(Sender: TObject);
var
  FormData: TGotoOffsetData;
  Rate, Offset: Integer;
begin
  Rate := 1;
  Offset := 0;
  if ShowGotoOffsetForm(FormData) then
  begin
    case FormData.OffUnit of
      0: Rate := 1;
      1: Rate := 2;
      2: Rate := 4;
    end;
    case FormData.Relative of
      0: Offset := FormData.Offset * Rate;
      1: Offset := HexEdit.Offset + FormData.Offset * Rate;
      2: Offset := HexEdit.Offset - FormData.Offset * Rate;
      3: Offset := HexEdit.DataSize - 1 - FormData.Offset * Rate;
    end;
    HexEdit.Offset := Offset;
  end;
end;

procedure TChildForm.EditConvCharsetItemClick(Sender: TObject);

  procedure TransCharsetRange(Offset, Count: Integer; FromType, ToType: TCharsetType);
  var
    CurPtr: PChar;
    S: string;
  begin
    if FromType = ToType then Exit;
    CurPtr := HexEdit.DataAddr + Offset;

    SetLength(S, Count);
    Move(CurPtr^, S[1], Count);
    TranslateBufferToAnsi(FromType, @S[1], @S[1], Count);
    TranslateBufferFromAnsi(ToType, @S[1], @S[1], Count);
    HexEdit.ModifyData(Offset, S[1], Count, True);
  end;

var
  FormData: TConvChrsetData;
  StartOffset, Count: Integer;
begin
  if ShowConvChrsetForm(FormData) then
  begin
    if FormData.OnlyBlock then
    begin
      if not CheckSelExists then Exit;
      StartOffset := HexEdit.SelStart;
      Count := HexEdit.SelLength;
    end else
    begin
      StartOffset := 0;
      Count := HexEdit.DataSize;
    end;
    TransCharsetRange(StartOffset, Count, FormData.FromType, FormData.ToType);

    ShowStatusInfo;
    FillDataInspector;
  end;
end;

procedure TChildForm.EditConvCryptItemClick(Sender: TObject);

  procedure TransCryptRange(Offset, Count: Integer; const Password: string;
    Encrypt: Boolean);
  const
    MaxKeySize = 256;
  var
    Gost: TGost;
    Key: array[0..MaxKeySize-1] of Byte;
    S: string;
    CurPtr: PChar;
  begin
    CurPtr := HexEdit.DataAddr + Offset;

    SetLength(S, Count);
    Move(CurPtr^, S[1], Count);

    FillChar(Key[0], MaxKeySize, 0);
    StrLCopy(@Key[0], PChar(Password), MaxKeySize);
    Gost := TGost.Create(@Key[0]);
    if Encrypt then
      Gost.GostEncryptCFB(@S[1], @S[1], Count)
    else
      Gost.GostDecryptCFB(@S[1], @S[1], Count);
    Gost.Free;

    HexEdit.ModifyData(Offset, S[1], Count, True);
  end;

var
  FormData: TConvCryptData;
  StartOffset, Count: Integer;
begin
  if ShowConvCryptForm(FormData) then
  begin
    if FormData.OnlyBlock then
    begin
      if not CheckSelExists then Exit;
      StartOffset := HexEdit.SelStart;
      Count := HexEdit.SelLength;
    end else
    begin
      StartOffset := 0;
      Count := HexEdit.DataSize;
    end;
    TransCryptRange(StartOffset, Count, FormData.Key, FormData.Encrypt);

    ShowStatusInfo;
    FillDataInspector;
  end;
end;

procedure TChildForm.EditConvCaseItemClick(Sender: TObject);

  procedure TransCaseRange(Offset, Count: Integer; LowerToUpper: Boolean);
  var
    CurPtr: PChar;
    I: Integer;
    S: string;
  begin
    CurPtr := HexEdit.DataAddr + Offset;

    SetLength(S, Count);
    Move(CurPtr^, S[1], Count);

    for I := 1 to Count  do
    begin
      if LowerToUpper then
      begin
        if (S[I] <= 'z') and (S[I] >= 'a') then Dec(S[I], 32);
      end else
        if (S[I] <= 'Z') and (S[I] >= 'A') then Inc(S[I], 32);
    end;

    HexEdit.ModifyData(Offset, S[1], Count, True);
  end;

var
  FormData: TConvCaseData;
  StartOffset, Count: Integer;
begin
  if ShowConvCaseForm(FormData) then
  begin
    if FormData.OnlyBlock then
    begin
      if not CheckSelExists then Exit;
      StartOffset := HexEdit.SelStart;
      Count := HexEdit.SelLength;
    end else
    begin
      StartOffset := 0;
      Count := HexEdit.DataSize;
    end;
    TransCaseRange(StartOffset, Count, FormData.LowerToUpper);

    ShowStatusInfo;
    FillDataInspector;
  end;
end;

procedure TChildForm.SearchTextItemClick(Sender: TObject);
var
  FormData: TSearchTextData;
begin
  if ShowSearchTextForm(FormData) then
  begin
    SearchMgr.SearchKind := skSearchText;
    SearchMgr.SearchTextData := FormData;
    SearchMgr.SearchFirst;
  end;
end;

procedure TChildForm.SearchHexItemClick(Sender: TObject);
var
  FormData: TSearchHexData;
begin
  if ShowSearchHexForm(FormData) then
  begin
    SearchMgr.SearchKind := skSearchHex;
    SearchMgr.SearchHexData := FormData;
    SearchMgr.SearchFirst;
  end;
end;

procedure TChildForm.SearchIntegerItemClick(Sender: TObject);
var
  FormData: TSearchIntData;
begin
  if ShowSearchIntForm(FormData) then
  begin
    SearchMgr.SearchKind := skSearchInt;
    SearchMgr.SearchIntData := FormData;
    SearchMgr.SearchFirst;
  end;
end;

procedure TChildForm.SearchFloatItemClick(Sender: TObject);
var
  FormData: TSearchFloatData;
begin
  if ShowSearchFloatForm(FormData) then
  begin
    SearchMgr.SearchKind := skSearchFloat;
    SearchMgr.SearchFloatData := FormData;
    SearchMgr.SearchFirst;
  end;
end;

procedure TChildForm.SearchReplaceTextItemClick(Sender: TObject);
var
  FormData: TReplaceTextData;
  R: Integer;
begin
  R := ShowReplaceTextForm(FormData);
  if R = mrOk then
  begin
    SearchMgr.SearchKind := skReplaceText;
    SearchMgr.ReplaceTextData := FormData;
    SearchMgr.ReplaceFirst;
  end;
  if R = mrReplaceAll then
  begin
    SearchMgr.SearchKind := skReplaceText;
    SearchMgr.ReplaceTextData := FormData;
    SearchMgr.ReplaceAll;
  end;
end;

procedure TChildForm.SearchReplaceHexItemClick(Sender: TObject);
var
  FormData: TReplaceHexData;
  R: Integer;
begin
  R := ShowReplaceHexForm(FormData);
  if R = mrOk then
  begin
    SearchMgr.SearchKind := skReplaceHex;
    SearchMgr.ReplaceHexData := FormData;
    SearchMgr.ReplaceFirst;
  end;
  if R = mrReplaceAll then
  begin
    SearchMgr.SearchKind := skReplaceHex;
    SearchMgr.ReplaceHexData := FormData;
    SearchMgr.ReplaceAll;
  end;
end;

procedure TChildForm.SearchNextItemClick(Sender: TObject);
begin
  case SearchMgr.SearchKind of
    skNone:
      SearchTextItemClick(nil);
    skSearchText, skSearchHex, skSearchInt, skSearchFloat:
      SearchMgr.SearchNext;
    skReplaceText, skReplaceHex:
      SearchMgr.ReplaceNext;
  end;
end;

procedure TChildForm.SearchFirstItemClick(Sender: TObject);
begin
  case SearchMgr.SearchKind of
    skNone:
      SearchTextItemClick(nil);
    skSearchText, skSearchHex, skSearchInt, skSearchFloat:
      SearchMgr.SearchFirst;
    skReplaceText, skReplaceHex:
      SearchMgr.ReplaceFirst;
  end;
end;

procedure TChildForm.SearchCompareItemClick(Sender: TObject);
var
  Data: TDataCompData;
begin
  if ShowDataCompForm(Data) then
  begin
    MainForm.ArrangeForCompare(Data.Para.Form1, Data.Para.Form2);
    CompareMgr.Para := Data.Para;
    CompareMgr.CompareFirst;
  end;
end;

procedure TChildForm.SearchCompareNextItemClick(Sender: TObject);
begin
  if not CompareMgr.FormExists then
    SearchCompareItemClick(nil)
  else
    CompareMgr.CompareNext;
end;

procedure TChildForm.HexEditCaretMove(Sender: TObject);
begin
  ShowStatusInfo;
  FillDataInspector;
end;

procedure TChildForm.HexEditSelectionChange(Sender: TObject);
begin
  ShowStatusInfo;
  AdjustClipboardEnabled;
  AdjustBlockEnabled;
end;

procedure TChildForm.HexEditChange(Sender: TObject);
begin
  AdjustUndoRedoEnabled;
end;

procedure TChildForm.HexEditDblClick(Sender: TObject);
begin
  case TDblClickAct(OptMgr.Values[SOptDblClickAct]) of
    daNumBaseConv:
      ShowNumBaseConvForm(Integer((HexEdit.DataAddr + HexEdit.Offset)^));
    daBkmkMgr:
      ShowBkmkMgrForm;
  end;
end;

procedure TChildForm.StatusBarMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  P: TPoint;
  W0, W1, W2, W3: Integer;
begin
  P := StatusBar.ClientToScreen(Point(X, Y));
  W0 := StatusBar.Panels[0].Width;
  W1 := StatusBar.Panels[1].Width;
  W2 := StatusBar.Panels[2].Width;
  W3 := StatusBar.Panels[3].Width;

  if (X >= 0) and (X <= W0) then
    LengthPopupMenu.Popup(P.x, P.y)
  else if X <= W0 + W1 then
    OffsetPopupMenu.Popup(P.x, P.y)
  else if X <= W0 + W1 + W2 then
    BlockInfoPopupMenu.Popup(P.x, P.y)
  else if X <= W0 + W1 + W2 + W3 then
    CurValuePopupMenu.Popup(P.x, P.y);
end;

procedure TChildForm.StatusBarResize(Sender: TObject);
var
  Index, I, W: Integer;
begin
  Index := StatusBar.Panels.Count - 2;
  W := 0;
  for I := 0 to StatusBar.Panels.Count - 1 do
  begin
    if I <> Index then
      Inc(W, StatusBar.Panels[I].Width);
  end;
  StatusBar.Panels[Index].Width := StatusBar.ClientWidth - W;
end;

procedure TChildForm.CurValPopup8sItemClick(Sender: TObject);
begin
  SetCurValueType(vt8s);
end;

procedure TChildForm.CurValPopup8uItemClick(Sender: TObject);
begin
  SetCurValueType(vt8u);
end;

procedure TChildForm.CurValPopup16sItemClick(Sender: TObject);
begin
  SetCurValueType(vt16s);
end;

procedure TChildForm.CurValPopup16uItemClick(Sender: TObject);
begin
  SetCurValueType(vt16u);
end;

procedure TChildForm.CurValPopup32sItemClick(Sender: TObject);
begin
  SetCurValueType(vt32s);
end;

procedure TChildForm.CurValPopup32uItemClick(Sender: TObject);
begin
  SetCurValueType(vt32u);
end;

procedure TChildForm.CurValPopupSingleItemClick(Sender: TObject);
begin
  SetCurValueType(vtSingle);
end;

procedure TChildForm.CurValPopupDoubleItemClick(Sender: TObject);
begin
  SetCurValueType(vtDouble);
end;

procedure TChildForm.LenPopupDecItemClick(Sender: TObject);
begin
  SetLengthNumBase(raDec);
end;

procedure TChildForm.LenPopupHexItemClick(Sender: TObject);
begin
  SetLengthNumBase(raHex);
end;

procedure TChildForm.OffPopupDecItemClick(Sender: TObject);
begin
  SetOffsetNumBase(raDec);
end;

procedure TChildForm.OffPopupHexItemClick(Sender: TObject);
begin
  SetOffsetNumBase(raHex);
end;

procedure TChildForm.BlkPopupDecItemClick(Sender: TObject);
begin
  SetBlockInfoNumBase(raDec);
end;

procedure TChildForm.BlkPopupHexItemClick(Sender: TObject);
begin
  SetBlockInfoNumBase(raHex);
end;

procedure TChildForm.BlockInfoPopupMenuPopup(Sender: TObject);
var
  Len: Integer;
begin
  Len := HexEdit.SelLength;
  if Len < 0 then Len := 0;
  BlkPopupBlockLenItem.Caption := '鳤' + IntToStr(Len);
end;

procedure TChildForm.PosGotoFirstItemClick(Sender: TObject);
begin
  HexEdit.MoveCaret(mcStart);
end;

procedure TChildForm.PosGotoEndItemClick(Sender: TObject);
begin
  HexEdit.MoveCaret(mcEnd);
end;

procedure TChildForm.PosGotoBlockStartItemClick(Sender: TObject);
begin
  HexEdit.MoveCaret(mcSelStart);
end;

procedure TChildForm.PosGotoBlockEndItemClick(Sender: TObject);
begin
  HexEdit.MoveCaret(mcSelEnd);
end;

procedure TChildForm.PosGotoLineFirstItemClick(Sender: TObject);
begin
  HexEdit.MoveCaret(mcLineStart);
end;

procedure TChildForm.PosGotoLineEndItemClick(Sender: TObject);
begin
  HexEdit.MoveCaret(mcLineEnd);
end;

procedure TChildForm.PosDefBkItemClick(Sender: TObject);
begin
  HexEdit.SetBookmark((Sender as TMenuItem).Tag);
end;

procedure TChildForm.PosGotoBkItemClick(Sender: TObject);
begin
  HexEdit.GotoBookmark((Sender as TMenuItem).Tag);
end;

procedure TChildForm.PosDefBookmarkItemClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to 9 do
    (FindComponent('PosDefBk'+IntToStr(I)+'Item') as TMenuItem).Checked := HexEdit.BookmarkExists(I);
end;

procedure TChildForm.PosGotoBookmarkItemClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to 9 do
    (FindComponent('PosGotoBk'+IntToStr(I)+'Item') as TMenuItem).Checked := HexEdit.BookmarkExists(I);
end;

procedure TChildForm.PopupShowNumBaseItemClick(Sender: TObject);
begin
  ShowNumBaseConvForm(Integer((HexEdit.DataAddr + HexEdit.Offset)^));
end;

procedure TChildForm.PopupShowBkmkMgrItemClick(Sender: TObject);
begin
  ShowBkmkMgrForm;
end;

initialization
  SearchMgr := TSearchMgr.Create;
  CompareMgr := TCompareMgr.Create;

finalization
  SearchMgr.Free;
  CompareMgr.Free;

end.
