unit ConvCaseFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TConvCaseData = record
    LowerToUpper: Boolean;
    OnlyBlock: Boolean;
  end;

  TConvCaseForm = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    CaseTypeRadioGroup: TRadioGroup;
    OnlyBlockCheckBox: TCheckBox;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetData(var Value: TConvCaseData);
  end;

var
  ConvCaseForm: TConvCaseForm;

function ShowConvCaseForm(var Value: TConvCaseData): Boolean;

implementation

{$R *.DFM}

function ShowConvCaseForm(var Value: TConvCaseData): Boolean;
var
  Frm: TConvCaseForm;
begin
  Frm := TConvCaseForm.Create(Application);
  Result := (Frm.ShowModal = mrOk);
  if Result  then Frm.GetData(Value);
  Frm.Free;
end;

procedure TConvCaseForm.GetData(var Value: TConvCaseData);
begin
  Value.LowerToUpper := (CaseTypeRadioGroup.ItemIndex = 0);
  Value.OnlyBlock := OnlyBlockCheckBox.Checked;
end;

procedure TConvCaseForm.OkButtonClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TConvCaseForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
