unit DiskIOFrm;

interface

{$WARN UNIT_PLATFORM OFF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TDiskIOData = record
    Drive: Char;
    SectorStart: Integer;
    SectorCount: Integer;
  end;

  TDiskIOForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    DriveComboBox: TDriveComboBox;
    Label2: TLabel;
    Label3: TLabel;
    FromSectorEdit: TEdit;
    SectorCountEdit: TEdit;
    OkButton: TButton;
    CanclButton: TButton;
    procedure OkButtonClick(Sender: TObject);
    procedure CanclButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetData(var Value: TDiskIOData);
  end;

var
  DiskIOForm: TDiskIOForm;

function ShowDiskIOForm(ReadSector: Boolean; var Value: TDiskIOData): Boolean;

implementation

{$R *.DFM}

function ShowDiskIOForm(ReadSector: Boolean; var Value: TDiskIOData): Boolean;
var
  Frm: TDiskIOForm;
begin
  Frm := TDiskIOForm.Create(Application);
  if ReadSector then Frm.Caption := ''
  else
  begin
    Frm.Caption := 'д';
    Frm.SectorCountEdit.Text := '';
    Frm.SectorCountEdit.Enabled := False;
    Frm.SectorCountEdit.Color := clBtnFace;
  end;
  Result := (Frm.ShowModal = mrOk);
  if Result then Frm.GetData(Value);
end;

procedure TDiskIOForm.GetData(var Value: TDiskIOData);
begin
  Value.Drive := UpCase(DriveComboBox.Drive);
  Value.SectorStart := StrToIntDef(FromSectorEdit.Text, 0);
  Value.SectorCount := StrToIntDef(SectorCountEdit.Text, 1);
end;

procedure TDiskIOForm.OkButtonClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TDiskIOForm.CanclButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
