unit ExportFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls;

type
  TExportData = record
    FileName: string;
    OnlyBlock: Boolean;
    IncAddr: Boolean;
  end;

  TExportForm = class(TForm)
    SaveDialog: TSaveDialog;
    Label1: TLabel;
    FileNameEdit: TEdit;
    BrowseSpeedButton: TSpeedButton;
    OkButton: TButton;
    CancelButton: TButton;
    GroupBox1: TGroupBox;
    OnlyBlockCheckBox: TCheckBox;
    IncAddrCheckBox: TCheckBox;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure BrowseSpeedButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetData(var Value: TExportData);
  end;

var
  ExportForm: TExportForm;

function ShowExportForm(var Value: TExportData): Boolean;

implementation

uses Misc;

{$R *.DFM}

function ShowExportForm(var Value: TExportData): Boolean;
var
  Frm: TExportForm;
begin
  Frm := TExportForm.Create(Application);
  Result := (Frm.ShowModal = mrOk);
  if Result  then Frm.GetData(Value);
  Frm.Free;
end;

procedure TExportForm.GetData(var Value: TExportData);
begin
  Value.FileName := FileNameEdit.Text;
  Value.OnlyBlock := OnlyBlockCheckBox.Checked;
  Value.IncAddr := IncAddrCheckBox.Checked;
end;

procedure TExportForm.OkButtonClick(Sender: TObject);
begin
  if FileNameEdit.Text = '' then
  begin
    MsgBox('дļ');
    Exit;
  end;
  ModalResult := mrOk;
end;

procedure TExportForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TExportForm.BrowseSpeedButtonClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    FileNameEdit.Text := SaveDialog.FileName; 
end;

end.
