unit GotoOffsetFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TGotoOffsetData = record
    Offset: Integer;
    OffUnit: Integer;
    Relative: Integer;
  end;

  TGotoOffsetForm = class(TForm)
    GroupBox1: TGroupBox;
    OffsetEdit: TEdit;
    UnitComboBox: TComboBox;
    RelativeRadioGroup: TRadioGroup;
    OkButton: TButton;
    CancelButton: TButton;
    DecRadioButton: TRadioButton;
    HexRadioButton: TRadioButton;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function CheckValid: Boolean;
  public
    { Public declarations }
    procedure GetData(var Value: TGotoOffsetData);

  end;

var
  GotoOffsetForm: TGotoOffsetForm;

function ShowGotoOffsetForm(var Value: TGotoOffsetData): Boolean;

implementation

uses Misc, NumBase;

{$R *.DFM}

function ShowGotoOffsetForm(var Value: TGotoOffsetData): Boolean;
var
  Frm: TGotoOffsetForm;
begin
  Frm := TGotoOffsetForm.Create(Application);
  Result := (Frm.ShowModal = mrOk);
  if Result then Frm.GetData(Value);
  Frm.Free;
end;

procedure TGotoOffsetForm.GetData(var Value: TGotoOffsetData);
begin
  if DecRadioButton.Checked then
    Value.Offset := StrToIntDef(OffsetEdit.Text, 0)
  else
    StrToIntAsHex(Value.Offset, OffsetEdit.Text);
  Value.OffUnit := UnitComboBox.ItemIndex;
  Value.Relative := RelativeRadioGroup.ItemIndex;
end;

function TGotoOffsetForm.CheckValid: Boolean;
begin
  Result := True;
  if DecRadioButton.Checked then
  begin
    if not IsDecStr(OffsetEdit.Text) then
    begin
      Result := False;
      MsgBox('ƫֵȷ롣');
      OffsetEdit.SetFocus;
      OffsetEdit.SelectAll;
      Exit;
    end;
  end else
  begin
    if not IsHexStr(OffsetEdit.Text) then
    begin
      Result := False;
      MsgBox('ƫֵȷ롣');
      OffsetEdit.SetFocus;
      OffsetEdit.SelectAll;
      Exit;
    end;
  end;
end;

procedure TGotoOffsetForm.FormCreate(Sender: TObject);
begin
  UnitComboBox.ItemIndex := 0;
end;

procedure TGotoOffsetForm.OkButtonClick(Sender: TObject);
begin
  if CheckValid then
    ModalResult := mrOk;
end;

procedure TGotoOffsetForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
