unit InpBkmkFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, BkmkMgr;

type
  TInpBkmkForm = class(TForm)
    OkButton: TButton;
    CanclButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    OffsetEdit: TEdit;
    DescriptionEdit: TEdit;
    procedure OkButtonClick(Sender: TObject);
    procedure CanclButtonClick(Sender: TObject);
  private
    { Private declarations }
    function CheckValid: Boolean;
  public
    { Public declarations }
    procedure SetData(Value: TBkmkItem);
    procedure GetData(var Value: TBkmkItem);
  end;

var
  InpBkmkForm: TInpBkmkForm;

function ShowInpBkmkForm(var Value: TBkmkItem): Boolean;

implementation

{$R *.DFM}

uses
  Misc;

function ShowInpBkmkForm(var Value: TBkmkItem): Boolean;
var
  Frm: TInpBkmkForm;
begin
  Frm := TInpBkmkForm.Create(Application);
  Frm.SetData(Value);
  Result := (Frm.ShowModal = mrOk);
  Frm.GetData(Value);
  Frm.Free;
end;

procedure TInpBkmkForm.SetData(Value: TBkmkItem);
begin
  OffsetEdit.Text := IntToStr(Value.Offset);
  DescriptionEdit.Text := Value.Description;
end;

procedure TInpBkmkForm.GetData(var Value: TBkmkItem);
begin
  Value.Offset := StrToIntDef(OffsetEdit.Text, 0);
  Value.Description := DescriptionEdit.Text;
end;

function TInpBkmkForm.CheckValid: Boolean;
begin
  Result := True;
  if not IsInt(OffsetEdit.Text) then
  begin
    Result := False;
    MsgBox('ƫֵȷ');
    OffsetEdit.SetFocus;
    Exit;
  end;
end;

procedure TInpBkmkForm.OkButtonClick(Sender: TObject);
begin
  if CheckValid then
    ModalResult := mrOk;
end;

procedure TInpBkmkForm.CanclButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
