unit InputFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TInputForm = class(TForm)
    PromptLabel: TLabel;
    OkButton: TButton;
    CancelButton: TButton;
    ValueEdit: TEdit;
    procedure OkButtonClick(Sender: TObject);
    procedure CanclButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetData(Value: string);
    procedure GetData(var Value: string);
  end;

var
  InputForm: TInputForm;

function ShowInputForm(Caption, Msg: string; var Value: string): Boolean;

implementation

{$R *.DFM}

function ShowInputForm(Caption, Msg: string; var Value: string): Boolean;
var
  Frm: TInputForm;
begin    
  Frm := TInputForm.Create(Application);
  Frm.Caption := Caption;
  Frm.PromptLabel.Caption := Msg;
  Frm.SetData(Value);
  Result := (Frm.ShowModal = mrOk);
  if Result then Frm.GetData(Value);
  Frm.Free;
end;

procedure TInputForm.SetData(Value: string);
begin
  ValueEdit.Text := Value;
end;

procedure TInputForm.GetData(var Value: string);
begin
  Value := ValueEdit.Text;
end;

procedure TInputForm.OkButtonClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TInputForm.CanclButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
