unit InsCharFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Misc;

type
  TInsCharData = record
    Fixed: Boolean;
    FixValue: Byte;
    RndFromVal: Integer;
    RndToVal: Integer;
    Count: Integer;
  end;

  TInsCharForm = class(TForm)
    GroupBox1: TGroupBox;
    FixValComboBox: TComboBox;
    FixValRadioButton: TRadioButton;
    RndValRadioButton: TRadioButton;
    Label1: TLabel;
    Label3: TLabel;
    RndFromEdit: TEdit;
    RndToEdit: TEdit;
    CountComboBox: TComboBox;
    Label2: TLabel;
    RndFromUpDown: TUpDown;
    RndToUpDown: TUpDown;
    OkButton: TButton;
    CancelButton: TButton;
    Bevel1: TBevel;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FixValRadioButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function CheckValid: Boolean;

  public
    { Public declarations }
    procedure SetData(Value: TInsCharData);
    procedure GetData(var Value: TInsCharData);

  end;

var
  InsCharForm: TInsCharForm;

function ShowInsCharForm(var Value: TInsCharData): Boolean;

implementation

{$R *.DFM}

function ShowInsCharForm(var Value: TInsCharData): Boolean;
var
  Frm: TInsCharForm;
begin
  Frm := TInsCharForm.Create(Application);
  Result := (Frm.ShowModal = mrOk);
  if Result then Frm.GetData(Value);
  Frm.Free;
end;

function TInsCharForm.CheckValid: Boolean;
var
  I, J: Integer;
begin
  if not IsInt(FixValComboBox.Text) or
     not IsInt(CountComboBox.Text) then
  begin
    MsgBox('ֵȷ');
    Result := False;
    Exit;
  end;
  I := StrToInt(FixValComboBox.Text);
  if (I < 0) or (I > 255) then
  begin
    MsgBox('̶ֵ0-255֮䡣');
    FixValComboBox.SelectAll;
    FixValComboBox.SetFocus;
    Result := False;
    Exit;
  end;
  I := StrToInt(CountComboBox.Text);
  if (I <= 0) then
  begin
    MsgBox('ֽ0');
    CountComboBox.SelectAll;
    CountComboBox.SetFocus;
    Result := False;
    Exit;
  end;
  I := RndFromUpDown.Position;
  J := RndToUpDown.Position;
  if (I > J) then
  begin
    MsgBox('ֵʼֵСֵ');
    Result := False;
    Exit;
  end;
  Result := True;
end;

procedure TInsCharForm.SetData(Value: TInsCharData);
begin
  FixValRadioButton.Checked := Value.Fixed;
  RndValRadioButton.Checked := not Value.Fixed;
  FixValComboBox.Text := IntToStr(Value.FixValue);
  RndFromUpDown.Position := Value.RndFromVal;
  RndToUpDown.Position := Value.RndToVal;
  CountComboBox.Text := IntToStr(Value.Count);
end;

procedure TInsCharForm.GetData(var Value: TInsCharData);
begin
  Value.Fixed := FixValRadioButton.Checked;
  Value.FixValue := StrToIntDef(FixValComboBox.Text, 0);
  Value.RndFromVal := RndFromUpDown.Position;
  Value.RndToVal := RndToUpDown.Position;
  Value.Count := StrToIntDef(CountComboBox.Text, 0);
end;

procedure TInsCharForm.OkButtonClick(Sender: TObject);
begin
  if CheckValid then
    ModalResult := mrOk;
end;

procedure TInsCharForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TInsCharForm.FixValRadioButtonClick(Sender: TObject);
begin
  if FixValRadioButton.Checked then
  begin
    RndFromUpDown.Enabled := False;
    RndToUpDown.Enabled := False;
    RndFromEdit.Enabled := False;
    RndToEdit.Enabled := False;
    FixValComboBox.Enabled := True;
    RndFromEdit.Color := clBtnFace;
    RndToEdit.Color := clBtnFace;
    FixValComboBox.Color := clWindow;
  end else
  begin
    RndFromUpDown.Enabled := True;
    RndToUpDown.Enabled := True;
    RndFromEdit.Enabled := True;
    RndToEdit.Enabled := True;
    FixValComboBox.Enabled := False;
    RndFromEdit.Color := clWindow;
    RndToEdit.Color := clWindow;
    FixValComboBox.Color := clBtnFace;
  end;
end;

procedure TInsCharForm.FormCreate(Sender: TObject);
begin
  FixValRadioButtonClick(Sender);
end;

end.
