unit PrintFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TPrintData = record
    OnlyBlock: Boolean;
    IncAddr: Boolean;
    PrintFileName: Boolean;
  end;

  TPrintForm = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    GroupBox1: TGroupBox;
    OnlyBlockCheckBox: TCheckBox;
    IncAddrCheckBox: TCheckBox;
    PrinterSetupButton: TButton;
    PrintFileNameCheckBox: TCheckBox;
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure PrinterSetupButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetData(var Value: TPrintData);

  end;

var
  PrintForm: TPrintForm;

function ShowPrintForm(var Value: TPrintData): Boolean;

implementation

{$R *.DFM}

uses MainFrm;

function ShowPrintForm(var Value: TPrintData): Boolean;
var
  Frm: TPrintForm;
begin
  Frm := TPrintForm.Create(Application);
  Result := (Frm.ShowModal = mrOk);
  if Result  then Frm.GetData(Value);
  Frm.Free;
end;

procedure TPrintForm.GetData(var Value: TPrintData);
begin
  Value.OnlyBlock := OnlyBlockCheckBox.Checked;
  Value.IncAddr := IncAddrCheckBox.Checked;
  Value.PrintFileName := PrintFileNameCheckBox.Checked;
end;

procedure TPrintForm.OkButtonClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TPrintForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TPrintForm.PrinterSetupButtonClick(Sender: TObject);
begin
  MainForm.FilePrintSetupItemClick(nil);
end;

end.
