unit ReplaceTextFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, HexEdit;

const
  mrReplaceAll = 10;

type
  TReplaceTextData = record
    FromText: string;
    ToText: string;
    AllDoc: Boolean;
    AskRep: Boolean;
    Opt: TSearchTextOptions;
  end;

  TReplaceTextForm = class(TForm)
    Label1: TLabel;
    FromComboBox: TComboBox;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    UseWildCheckBox: TCheckBox;
    WildCharEdit: TEdit;
    WildCountEdit: TEdit;
    GroupBox2: TGroupBox;
    MatchCaseCheckBox: TCheckBox;
    WholeWordCheckBox: TCheckBox;
    OnlyBlockCheckBox: TCheckBox;
    AllDocCheckBox: TCheckBox;
    UnicodeCheckBox: TCheckBox;
    ReplaceButton: TButton;
    CancelButton: TButton;
    HelpButton: TButton;
    DefaultButton: TButton;
    Label4: TLabel;
    ToComboBox: TComboBox;
    AskCheckBox: TCheckBox;
    ReplaceAllButton: TButton;
    procedure ReplaceButtonClick(Sender: TObject);
    procedure ReplaceAllButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure DefaultButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure UseWildCheckBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function CheckValid: Boolean;
  public
    { Public declarations }
    procedure GetData(var Value: TReplaceTextData);
  end;

var
  ReplaceTextForm: TReplaceTextForm;

function ShowReplaceTextForm(var Value: TReplaceTextData): Integer;

implementation

uses Misc, NumBase;

{$R *.DFM}

function ShowReplaceTextForm(var Value: TReplaceTextData): Integer;
begin
  Result := ReplaceTextForm.ShowModal;
  if Result <> mrCancel then ReplaceTextForm.GetData(Value);
end;

procedure TReplaceTextForm.GetData(var Value: TReplaceTextData);
begin
  Value.FromText := FromComboBox.Text;
  Value.ToText := ToComboBox.Text;
  Value.AllDoc := AllDocCheckBox.Checked;
  Value.AskRep:= AskCheckBox.Checked;
  Value.Opt.MatchCase := MatchCaseCheckBox.Checked;
  Value.Opt.WholeWord := WholeWordCheckBox.Checked;
  Value.Opt.Unicode := UnicodeCheckBox.Checked;
  Value.Opt.OnlyBlock := OnlyBlockCheckBox.Checked;
  Value.Opt.UseWild := UseWildCheckBox.Checked;
  Value.Opt.WildChar := WildCharEdit.Text[1];
  Value.Opt.WildCount := StrToIntDef(WildCountEdit.Text, 1);
end;

function TReplaceTextForm.CheckValid: Boolean;
var
  R: Integer;
begin
  Result := True;
  if FromComboBox.Text = '' then
  begin
    Result := False;
    FromComboBox.SetFocus;
    Exit;
  end;
  if Length(FromComboBox.Text) <> Length(ToComboBox.Text) then
  begin
    R := MsgBox('Ҵ滻ĳȲһ£', MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON2);
    if R = ID_NO then
    begin
      Result := False;
      Exit;
    end;
  end;
  if Length(WildCharEdit.Text) <> 1 then
  begin
    Result := False;
    MsgBox('ͨȷ');
    WildCharEdit.SetFocus;
    Exit;
  end;
  if not IsDecStr(WildCountEdit.Text) then
  begin
    Result := False;
    MsgBox('ֽͨȷ');
    WildCountEdit.SetFocus;
    Exit;
  end;
end;

procedure TReplaceTextForm.FormCreate(Sender: TObject);
begin
  UseWildCheckBoxClick(nil);
end;

procedure TReplaceTextForm.ReplaceButtonClick(Sender: TObject);
begin
  if CheckValid then
  begin
    FromComboBox.Items.Insert(0, FromComboBox.Text);
    ToComboBox.Items.Insert(0, ToComboBox.Text);
    ModalResult := mrOk;
  end;
end;

procedure TReplaceTextForm.ReplaceAllButtonClick(Sender: TObject);
begin
  if CheckValid then
  begin
    FromComboBox.Items.Insert(0, FromComboBox.Text);
    ToComboBox.Items.Insert(0, ToComboBox.Text);
    ModalResult := mrReplaceAll;
  end;
end;

procedure TReplaceTextForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TReplaceTextForm.HelpButtonClick(Sender: TObject);
begin
//
end;

procedure TReplaceTextForm.DefaultButtonClick(Sender: TObject);
begin
  FromComboBox.Text := '';
  ToComboBox.Text := '';
  MatchCaseCheckBox.Checked := False;
  WholeWordCheckBox.Checked := False;
  UnicodeCheckBox.Checked := False;
  OnlyBlockCheckBox.Checked := False;
  AllDocCheckBox.Checked := False;
  AskCheckBox.Checked := False;
  UseWildCheckBox.Checked := False;
  WildCharEdit.Text := '?';
  WildCountEdit.Text := '1';
end;

procedure TReplaceTextForm.FormActivate(Sender: TObject);
begin
  FromComboBox.SetFocus;
end;

procedure TReplaceTextForm.UseWildCheckBoxClick(Sender: TObject);
begin
  if UseWildCheckBox.Checked then
  begin
    WildCharEdit.Enabled := True;
    WildCountEdit.Enabled := True;
    WildCharEdit.Color := clWindow;
    WildCountEdit.Color := clWindow;
  end else
  begin
    WildCharEdit.Enabled := False;
    WildCountEdit.Enabled := False;
    WildCharEdit.Color := clBtnFace;
    WildCountEdit.Color := clBtnFace;
  end;
end;

end.
