unit TransCharset;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls;

const
  MacToISO: array[128..255] of Char = (
                      #$C4,#$C5,#$C7,#$C9,#$D1,#$D6,#$DC,#$E1,#$E0,#$E2,#$E4,#$E3,#$E5,#$E7,#$E9,#$E8,
                      #$EA,#$EB,#$ED,#$EC,#$EE,#$EF,#$F1,#$F3,#$F2,#$F4,#$F6,#$F5,#$FA,#$F9,#$FB,#$FC,
                      #$DD,#$B0,#$A2,#$A3,#$A7,#$80,#$B6,#$DF,#$AE,#$A9,#$81,#$B4,#$A8,#$82,#$C6,#$D8,
                      #$83,#$B1,#$BE,#$84,#$A5,#$B5,#$8F,#$85,#$BD,#$BC,#$86,#$AA,#$BA,#$87,#$E6,#$F8,
                      #$BF,#$A1,#$AC,#$88,#$9F,#$89,#$90,#$AB,#$BB,#$8A,#$A0,#$C0,#$C3,#$D5,#$91,#$A6,
                      #$AD,#$8B,#$B3,#$B2,#$8C,#$B9,#$F7,#$D7,#$FF,#$8D,#$8E,#$A4,#$D0,#$F0,#$DE,#$FE,
                      #$FD,#$B7,#$92,#$93,#$94,#$C2,#$CA,#$C1,#$CB,#$C8,#$CD,#$CE,#$CF,#$CC,#$D3,#$D4,
                      #$95,#$D2,#$DA,#$DB,#$D9,#$9E,#$96,#$97,#$AF,#$98,#$99,#$9A,#$B8,#$9B,#$9C,#$9D );

  ISOToMac: array[128..255] of Char = (
                      #$A5,#$AA,#$AD,#$B0,#$B3,#$B7,#$BA,#$BD,#$C3,#$C5,#$C9,#$D1,#$D4,#$D9,#$DA,#$B6,
                      #$C6,#$CE,#$E2,#$E3,#$E4,#$F0,#$F6,#$F7,#$F9,#$FA,#$FB,#$FD,#$FE,#$FF,#$F5,#$C4,
                      #$CA,#$C1,#$A2,#$A3,#$DB,#$B4,#$CF,#$A4,#$AC,#$A9,#$BB,#$C7,#$C2,#$D0,#$A8,#$F8,
                      #$A1,#$B1,#$D3,#$D2,#$AB,#$B5,#$A6,#$E1,#$FC,#$D5,#$BC,#$C8,#$B9,#$B8,#$B2,#$C0,
                      #$CB,#$E7,#$E5,#$CC,#$80,#$81,#$AE,#$82,#$E9,#$83,#$E6,#$E8,#$ED,#$EA,#$EB,#$EC,
                      #$DC,#$84,#$F1,#$EE,#$EF,#$CD,#$85,#$D7,#$AF,#$F4,#$F2,#$F3,#$86,#$A0,#$DE,#$A7,
                      #$88,#$87,#$89,#$8B,#$8A,#$8C,#$BE,#$8D,#$8F,#$8E,#$90,#$91,#$93,#$92,#$94,#$95,
                      #$DD,#$96,#$98,#$97,#$99,#$9B,#$9A,#$D6,#$BF,#$9D,#$9C,#$9E,#$9F,#$E0,#$DF,#$D8 );

//  - ebcdic cp 38

  EBCDICToISO: array[0..255] of Char = (
                      #0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      ' ',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,'.','<','(','+','',
                      '&','&',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,'!','$','*',')',';',#0 ,
                      '-','/',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,'|',',','%','_','>','?',
                      #0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,'`',':','#','@','''','=','"',
                      #0 ,'a','b','c','d','e','f','g','h','i',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,'j','k','l','m','n','o','p','q','r',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,'~','s','t','u','v','w','x','y','z',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,'A','B','C','D','E','F','G','H','I',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      #0 ,'J','K','L','M','N','O','P','Q','R',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      '\',#0 ,'S','T','U','V','W','X','Y','Z',#0 ,#0 ,#0 ,#0 ,#0 ,#0 ,
                      '0','1','2','3','4','5','6','7','8','9',#0 ,#0 ,#0 ,#0 ,#0 ,#0  );

  ISOToEBCDIC: array[0..255] of Char = (
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      '@','Z','','{','[','l','P','}','M',']','\','N','k','`','K','a',
                      '','','','','','','','','','','z','^','L','~','n','o',
                      '|','','','','','','','','','','','','','','','',
                      '','','','','','','','','','','',#00,'',#00,#00,'m',
                      'y','','','','','','','','','','','','','','','',
                      '','','','','','','','','','','',#00,'j',#00,'',#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,
                      #00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,'O',#00 );

type
  TCharsetType = (ctAnsi, ctDos8, ctASCII, ctMac, ctEBCDIC);

procedure TranslateBufferFromAnsi(const AType: TCharsetType; BufferA, BufferB: PChar ; const ACount: Integer);
procedure TranslateBufferToAnsi(const AType: TCharsetType; BufferA, BufferB: PChar; const ACount: Integer);

implementation

// Translate the buffer from ANSI to the given translation mode
procedure TranslateBufferFromAnsi(const AType: TCharsetType; BufferA, BufferB: PChar ; const ACount: Integer);
var
  I: Integer;
  Ch: Char ;
begin
  case AType of
    ctAnsi    : Move(BufferA^, BufferB^, ACount);
    ctDOS8,
    ctASCII   : CharToOEMBuff(BufferA, BufferB, ACount);
    ctMAC     : if ACount > 0 then
                  for I := 0 to Pred(ACount) do
                  begin
                    Ch := BufferA[I];
                    if Ch < #128 then
                      BufferB[I] := Ch
                    else
                      BufferB[I] := ISOToMac[Ord(Ch)];
                  end;
    ctEBCDIC  : if ACount > 0 then
                  for I := 0 to Pred(ACount) do
                    BufferB[I] := ISOToEBCDIC[Ord(BufferA[I])];
  end;
end;

// Translate the buffer to ANSI from the given translation mode
procedure TranslateBufferToAnsi(const AType: TCharsetType; BufferA, BufferB: PChar; const ACount: Integer);
var
  I: Integer;
  Ch: Char;
begin
  case AType of
    ctAnsi    : Move(BufferA^, BufferB^, ACount);
    ctDOS8,
    ctASCII   : OEMToCharBuff(BufferA, BufferB, ACount);
    ctMAC     : if ACount > 0 then
                  for I := 0 to Pred(ACount) do
                  begin
                    Ch := BufferA[I];
                    if Ch < #128 then
                      BufferB[I] := Ch
                    else
                      BufferB[I] := MacToISO[Ord(Ch)];
                  end;
    ctEBCDIC  : if ACount > 0 then
                  for I := 0 to Pred(ACount) do
                    BufferB[I] := EBCDICToISO[Ord(BufferA[I])];
  end;
end;

end.
